﻿using NMemory;
using NMemory.Indexes;
using NMemory.Tables;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Database database = new Database();

        Table<Group , int> groupTable  = database.Tables.Create<Group , int>(group  => group.ID , null);
        Table<Member, int> memberTable = database.Tables.Create<Member, int>(member => member.ID, null);

        IIndex<Member, int?> memberGroupIDIndex = memberTable.CreateIndex(new RedBlackTreeIndexFactory(), member => member.GroupID);

        database.Tables.CreateRelation
        (
            groupTable.PrimaryKeyIndex,
            memberGroupIDIndex,
            x => x ?? -1,
            x => x
        );
    }

    #endregion
}